unit BeeGui_AboutFrm;

{ Contains:

  beeGUI AboutTo form.

  (C) 2005 Andrew Filinsky, Melchiorre Caruso

  Modifyed:

  v1.0.1 build 9143 - 2005/07/09 Melchiorre Caruso
  v1.0.1 build 9158 - 2005/07/24 Melchiorre Caruso

}

{$R-,Q-,S-}

interface

uses
  Buttons,
  Classes,
  Controls,
  StdCtrls,
  Graphics,
  ExtCtrls,
  SysUtils,

  BeeGui_Forms, BeeGui_ListView;


type
  TAboutFrm = class (TBGCustomForm)
    AboutFrm_Logo: TImage;
    AboutFrm_Title: TLabel;
    AboutFrm_MoreInfo: TLabel;
    AboutFrm_Web: TLabel;
    AboutFrm_Link: TLabel;
    AboutFrm_Ver: TLabel;
    AboutFrm_Build: TLabel;

    BtnOk: TBitBtn;
    BtnLicense: TBitBtn;
    AboutFrm_Ver_: TBGLabel;
    AboutFrm_Build_: TBGLabel;
    BGLabel1: TBGLabel;

    procedure BtnLicenseClick (Sender: TObject);
    procedure AboutFrm_LinkClick (Sender: TObject);

    procedure AboutFrm_LinkMouseMove (Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove (Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    
  end;

var
  AboutFrm: TAboutFrm;

implementation

{$R *.DFM}

uses
  BeeGui_WinOS,
  BeeGui_Common;

procedure TAboutFrm.BtnLicenseClick (Sender: TObject);
begin
  BG_ShellExecute (DoDelimiter (LIC_FILENAME), ExtractFilePath (ParamStr(0)));
end;

procedure TAboutFrm.AboutFrm_LinkClick(Sender: TObject);
begin
  BG_ShellExecute (AboutFrm_Link.Caption, '');
end;

procedure TAboutFrm.AboutFrm_LinkMouseMove (Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  AboutFrm_Link.Font.Style := [fsUnderline];
  AboutFrm_Link.Font.Color := clBlue;
end;

procedure TAboutFrm.FormMouseMove (Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  AboutFrm_Link.Font.Style := [];
  AboutFrm_Link.Font.Color := clBlue;
end;

procedure TAboutFrm.FormCreate(Sender: TObject);
var
  Version: ansistring;
  Major, Minor, Release, Build: integer;
begin
  Version := BG_FileVersion (ParamStr (0));

  BG_ExpandVersion (Version, Major, Minor, Release, Build);

  AboutFrm_Ver_.Caption   := IntToStr (Major) + '.' + IntToStr (Minor) + '.' + IntToStr (Release);
  AboutFrm_Build_.Caption := IntToStr (Build);
end;

end.
