unit BeeGui_MainFrm;

{ Contains:

  BeeGUI Main form.

  (C) 2005 Andrew Filinsky, Melchiorre Caruso

  Modifyed:

  v1.0.1 build 9156 - 2005/07/16 Melchiorre Caruso
  v1.0.1 build 9158 - 2005/07/24 Melchiorre Caruso
  v1.0.1 build 9160 - 2005/08/03 Melchiorre Caruso

}

{$R-,Q-,S-}

interface

uses
  Math,
  Forms,
  Menus,
  Classes,
  Dialogs,
  Buttons,
  ImgList,
  Windows,
  Messages,
  SysUtils,
  Graphics,
  Controls,
  ComCtrls,
  StdCtrls,
  ExtCtrls,
  FileCtrl,
  AppEvnts,

  BeeGui_Forms,
  BeeGui_ListView,
  BeeGui_Interfaces;

const
  PosCol     = 9;
  PathCol    = 8;

  BtnsCount  = 14;

  // MainFrm MSGs

  MSG_moveto            =  0;
  MSG_moveto_error      =  1;

  MSG_copyto            =  2;
  MSG_copyto_error      =  3;

  MSG_rename_arc        =  4;
  MSG_rename_arc_error  =  5;

  MSG_delete            =  6;
  MSG_delete_error      =  7;

  MSG_rename_file       =  8;
  MSG_renane_file_error =  9;

  MSG_default           = 10;
  MSG_default_error     = 11;

  MSG_delete_files      = 12;

  MSG_terminate_process = 13;
  MSG_process           = 14;

  MSG_no_files_selected = 15;

  MSG_selected_items    = 16;
  MSG_n_items           = 17;

  MSG_delete_checkout   = 18;
  MSG_checkout_error    = 19;

  MSG_set_cur_dir       = 20;

type
  TProcessAction = (paNew, paCheckOut, paView, paDefault);

type
  TMainFrm = class (TBGMainForm)
  
    MainFrm_ButtonsPanel: TPanel;
    MainFrm_Bevel: TBevel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    MainFrm_Spacer: TBevel;

    MainFrm_PathBox: TComboBox;
    MainFrm_StatusBar: TStatusBar;

    MainFrm_ListView: TBGListView;
    MainFrm_MSGs: TComboBox;

    // Buttons

    BtnUp: TSpeedButton;
    BtnOpen: TSpeedButton;
    BtnNew: TSpeedButton;
    BtnAdd: TSpeedButton;
    BtnExtract: TSpeedButton;
    BtnView: TSpeedButton;
    BtnDelete: TSpeedButton;
    BtnTest: TSpeedButton;
    BtnInfo: TSpeedButton;
    BtnCheckOut: TSpeedButton;
    BtnHelp: TSpeedButton;
    BtnExit: TSpeedButton;

    // Dialogs
    MainFrm_OpenDialog: TOpenDialog;
    MainFrm_SaveDialog: TSaveDialog;
    MainFrm_FontDialog: TFontDialog;

    MainFrm_PopupMenu: TPopupMenu;    
    MainFrm_PopupMenu_N1: TMenuItem;
    MainFrm_PopupMenu_N2: TMenuItem;
    MainFrm_PopupMenu_N3: TMenuItem;
    MainFrm_PopupMenu_Open: TMenuItem;
    MainFrm_PopupMenu_Delete: TMenuItem;
    MainFrm_PopupMenu_Extract: TMenuItem;
    MainFrm_PopupMenu_ExtractAll: TMenuItem;
    MainFrm_PopupMenu_Test: TMenuItem;
    MainFrm_PopupMenu_Rename: TMenuItem;

    MainFrm_PopupMenu_OrderBy: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Name: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Type: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Packed: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Size: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Ratio: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Method: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Modified: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Attributes: TMenuItem;
    MainFrm_PopupMenu_OrderBy_CRC: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Path: TMenuItem;
    MainFrm_PopupMenu_OrderBy_Position: TMenuItem;

    MainFrm_PopupMenu_Details: TMenuItem;
    MainFrm_PopupMenu_Details_Name: TMenuItem;
    MainFrm_PopupMenu_Details_Type: TMenuItem;
    MainFrm_PopupMenu_Details_Packed: TMenuItem;
    MainFrm_PopupMenu_Details_Size: TMenuItem;
    MainFrm_PopupMenu_Details_Ratio: TMenuItem;
    MainFrm_PopupMenu_Details_Method: TMenuItem;
    MainFrm_PopupMenu_Details_Modified: TMenuItem;
    MainFrm_PopupMenu_Details_Attributes: TMenuItem;
    MainFrm_PopupMenu_Details_CRC: TMenuItem;
    MainFrm_PopupMenu_Details_Path: TMenuItem;
    MainFrm_PopupMenu_Details_Position: TMenuItem;

    MainFrm_MainMenu: TMainMenu;
    MainFrm_MainMenu_File: TMenuItem;
    MainFrm_MainMenu_File_N1: TMenuItem;
    MainFrm_MainMenu_File_N2: TMenuItem;
    MainFrm_MainMenu_File_N3: TMenuItem;
    MainFrm_MainMenu_File_New: TMenuItem;
    MainFrm_MainMenu_File_Open: TMenuItem;
    MainFrm_MainMenu_File_Close: TMenuItem;
    MainFrm_MainMenu_File_Info: TMenuItem;
    MainFrm_MainMenu_File_Move: TMenuItem;
    MainFrm_MainMenu_File_Copy: TMenuItem;
    MainFrm_MainMenu_File_Rename: TMenuItem;
    MainFrm_MainMenu_File_Delete: TMenuItem;
    MainFrm_MainMenu_File_Exit: TMenuItem;

    MainFrm_MainMenu_View: TMenuItem;
    MainFrm_MainMenu_View_N1: TMenuItem;
    MainFrm_MainMenu_View_N2: TMenuItem;
    MainFrm_MainMenu_View_N3: TMenuItem;

    MainFrm_MainMenu_View_ToolBar: TMenuItem;
    MainFrm_MainMenu_View_ToolBar_Btns: TMenuItem;

    MainFrm_MainMenu_View_ToolBar_AddressBar: TMenuItem;

    MainFrm_MainMenu_View_StatusBar: TMenuItem;
    MainFrm_MainMenu_View_Icons: TMenuItem;
    MainFrm_MainMenu_View_SmallIcons: TMenuItem;
    MainFrm_MainMenu_View_List: TMenuItem;
    MainFrm_MainMenu_View_Report: TMenuItem;

    MainFrm_MainMenu_View_RowSelect: TMenuItem;
    MainFrm_MainMenu_View_GridLines: TMenuItem;
    MainFrm_MainMenu_View_ListMode: TMenuItem;

    MainFrm_MainMenu_View_OrderBy: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Name: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Type: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Packed: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Size: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Ratio: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Method: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Modified: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Attributes: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_CRC: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Path: TMenuItem;
    MainFrm_MainMenu_View_OrderBy_Position: TMenuItem;

    MainFrm_MainMenu_View_Details: TMenuItem;
    MainFrm_MainMenu_View_Details_Name: TMenuItem;
    MainFrm_MainMenu_View_Details_Type: TMenuItem;
    MainFrm_MainMenu_View_Details_Packed: TMenuItem;
    MainFrm_MainMenu_View_Details_Size: TMenuItem;
    MainFrm_MainMenu_View_Details_Ratio: TMenuItem;
    MainFrm_MainMenu_View_Details_Method: TMenuItem;
    MainFrm_MainMenu_View_Details_Modified: TMenuItem;
    MainFrm_MainMenu_View_Details_Attributes: TMenuItem;
    MainFrm_MainMenu_View_Details_CRC: TMenuItem;
    MainFrm_MainMenu_View_Details_Path: TMenuItem;
    MainFrm_MainMenu_View_Details_Position: TMenuItem;

    MainFrm_MainMenu_Actions: TMenuItem;
    MainFrm_MainMenu_Actions_N1: TMenuItem;
    MainFrm_MainMenu_Actions_N2: TMenuItem;
    MainFrm_MainMenu_Actions_Add: TMenuItem;
    MainFrm_MainMenu_Actions_Delete: TMenuItem;
    MainFrm_MainMenu_Actions_Extract: TMenuItem;
    MainFrm_MainMenu_Actions_ExtractAll: TMenuItem;
    MainFrm_MainMenu_Actions_Test: TMenuItem;
    MainFrm_MainMenu_Actions_Rename: TMenuItem;
    MainFrm_MainMenu_Actions_View: TMenuItem;
    MainFrm_MainMenu_Actions_SelectAll: TMenuItem;
    MainFrm_MainMenu_Actions_SelectMask: TMenuItem;
    MainFrm_MainMenu_Actions_DeselectMasks: TMenuItem;
    MainFrm_MainMenu_Actions_Invert: TMenuItem;
    MainFrm_MainMenu_Actions_CheckOut: TMenuItem;
    MainFrm_MainMenu_Actions_TestAll: TMenuItem;

    MainFrm_MainMenu_Options: TMenuItem;
    MainFrm_MainMenu_Options_N1: TMenuItem;
    MainFrm_MainMenu_Options_N2: TMenuItem;
    MainFrm_MainMenu_Options_Config: TMenuItem;
    MainFrm_MainMenu_Options_Password: TMenuItem;
    MainFrm_MainMenu_Options_SaveOnExit: TMenuItem;
    MainFrm_MainMenu_Options_SaveNow: TMenuItem;
    MainFrm_MainMenu_Options_Default: TMenuItem;
    MainFrm_MainMenu_Options_LogReport: TMenuItem;

    MainFrm_MainMenu_Help: TMenuItem;
    MainFrm_MainMenu_Help_N1: TMenuItem;
    MainFrm_MainMenu_Help_N2: TMenuItem;
    MainFrm_MainMenu_Help_F1: TMenuItem;
    MainFrm_MainMenu_Help_Internet: TMenuItem;
    MainFrm_MainMenu_Help_License: TMenuItem;
    MainFrm_MainMenu_Help_About: TMenuItem;
    MainFrm_PopupMenu_Btns: TPopupMenu;
    MainFrm_PopupMenu_Btns_New: TMenuItem;
    MainFrm_PopupMenu_Btns_Open: TMenuItem;
    MainFrm_PopupMenu_Btns_Spacer1: TMenuItem;
    MainFrm_PopupMenu_Btns_Add: TMenuItem;
    MainFrm_PopupMenu_Btns_Extract: TMenuItem;
    MainFrm_PopupMenu_Btns_View: TMenuItem;
    MainFrm_PopupMenu_Btns_Delete: TMenuItem;
    MainFrm_PopupMenu_Btns_Spacer2: TMenuItem;
    MainFrm_PopupMenu_Btns_Test: TMenuItem;
    MainFrm_PopupMenu_Btns_Info: TMenuItem;
    MainFrm_PopupMenu_Btns_CheckOut: TMenuItem;
    MainFrm_PopupMenu_Btns_Spacer3: TMenuItem;
    MainFrm_PopupMenu_Btns_Help: TMenuItem;
    MainFrm_PopupMenu_Btns_Exit: TMenuItem;
    MainFrm_ProgressBar: TProgressBar;

    // MainMenu_File Ckick;
    procedure MainFrm_MainMenu_File_NewClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_OpenClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_CloseClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_InfoClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_MoveClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_CopyClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_RenameClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_DeleteClick (Sender: TObject);
    procedure MainFrm_MainMenu_File_ExitClick (Sender: TObject);

    // MainMenu_View Click;
    procedure MainFrm_MainMenu_View_ToolBar_BtnsClick(Sender: TObject);

    procedure MainFrm_MainMenu_View_ToolBar_AddressBarClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_StatusBarClick (Sender: TObject);

    procedure MainFrm_MainMenu_View_IconsClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_SmallIconsClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_ListClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_ReportClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_RowSelectClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_GridLinesClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_ListModeClick (Sender: TObject);

    procedure MainFrm_MainMenu_View_OrderBy_NameClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_TypeClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_PackedClick ( Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_SizeClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_RatioClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_MethodClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_ModifiedClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_AttributesClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_CRCClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_PathClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_OrderBy_PositionClick (Sender: TObject);

    procedure MainFrm_MainMenu_View_Details_NameClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_TypeClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_PackedClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_SizeClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_RatioClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_MethodClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_ModifiedClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_AttributesClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_CRCClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_PathClick (Sender: TObject);
    procedure MainFrm_MainMenu_View_Details_PositionClick (Sender: TObject);

    // MainMenu_Actions Click;
    procedure MainFrm_MainMenu_Actions_AddClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_DeleteClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_ExtractClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_ExtractAllClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_TestClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_RenameClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_ViewClick (Sender: TObject);

    procedure MainFrm_MainMenu_Actions_SelectAllClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_SelectMaskClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_DeselectMasksClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_InvertClick (Sender: TObject);

    procedure MainFrm_MainMenu_Actions_TestAllClick (Sender: TObject);
    procedure MainFrm_MainMenu_Actions_CheckOutClick (Sender: TObject);

    // MainMenu_Options Click;
    procedure MainFrm_MainMenu_Options_ConfigClick (Sender: TObject);
    procedure MainFrm_MainMenu_Options_PasswordClick (Sender: TObject);
    procedure MainFrm_MainMenu_Options_SaveOnExitClick (Sender: TObject);
    procedure MainFrm_MainMenu_Options_SaveNowClick (Sender: TObject);
    procedure MainFrm_MainMenu_Options_DefaultClick (Sender: TObject);
    procedure MainFrm_MainMenu_Options_LogReportClick (Sender: TObject);

    // MainMenu_Help Click;
    procedure MainFrm_MainMenu_Help_F1Click (Sender: TObject);
    procedure MainFrm_MainMenu_Help_InternetClick (Sender: TObject);
    procedure MainFrm_MainMenu_Help_LicenseClick (Sender: TObject);
    procedure MainFrm_MainMenu_Help_AboutClick (Sender: TObject);

    // MainFrom;
    procedure FormCreate (Sender: TObject);
    procedure FormCloseQuery (Sender: TObject; var CanClose: Boolean);
    procedure FormClose (Sender: TObject; var Action: TCloseAction);
    procedure FormResize (Sender: TObject);

    // StatusBar;
    procedure MainFrm_StatusBarDrawPanel (StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure MainFrm_StatusBarResize (Sender: TObject);

    // Buttons Click;
    procedure BtnUpClick (Sender: TObject);

    // Popup Click;
    procedure MainFrm_PopupMenuPopup (Sender: TObject);

    // PathBox Click;
    procedure MainFrm_PathBoxClick (Sender: TObject);

    // ListViewColumn Click;
    procedure MainFrm_ListViewColumnClick (Sender: TObject; Column: TListColumn);
    procedure MainFrm_ListViewClick (Sender: TObject);


  public
    { Public declarations }

    MainFrm_ArcName: string;
    MainFrm_ArcInfo: TBGInfo;
    MainFrm_ParamS: TStringList;

    // Process
    MainFrm_Process: TBGThread;
    MainFrm_Process_Log: TStringList;
    MainFrm_Process_Action: TProcessAction;
    MainFrm_Process_Priority: integer;

    procedure StartProcess (CreateLog: boolean);

  private
    // Update Interfaces Procedures
    procedure UpdateOrder (by: integer);
    procedure UpdateDetail (index: integer);
    procedure UpdateStyle (index: integer);
    procedure UpdateCursor (Value: TCursor);
    procedure UpdateBtns;

    // Process procedures
    procedure ProcessOpening (Value: boolean);
    function  ProcessFiles (ParamS: TStringList): integer;

    procedure ProcessActionView (FileName:  string);
    procedure ProcessActionLog;
    procedure ProcessActionNew;
    procedure ProcessActionCheckOut;

  private
    // TBeeApp event procedures
    procedure OnOverWrite;
    procedure OnRename;
    procedure OnList;
    procedure OnTick;

    procedure OnError;
    procedure OnDisplay;
    procedure OnWarning;
    procedure OnDisplayLog;

    // TThread event procedures
    procedure OnTerminate (Sender: TObject);

  end;

var
  MainFrm: TMainFrm;
  BTNsArray: array [0..BtnsCount - 1] of TControl;

implementation

{$R *.DFM}

uses
  BeeGui_App,

  BeeGui_WinOS,
  BeeGui_AddFrm,
  BeeGui_Common,
  BeeGui_InfoFrm,
  BeeGui_AboutFrm,
  BeeGui_SeDeseFrm,
  BeeGui_RenameFrm,
  BeeGui_ConfigFrm,
  BeeGui_ExtractFrm,
  BeeGui_PasswordFrm,
  BeeGui_OverWriteFrm,
  BeeGui_IntViewerFrm,
  BeeGui_ChoiseViewerFrm;



  //------------------------------------------------------//
  //                                                      //
  // TMainFrm  Create, Close, Resize                      //
  //                                                      //
  //------------------------------------------------------//

  procedure TMainFrm.FormCreate (Sender: TObject);
  begin
    BTNsArray [ 0] := BtnNew;
    BTNsArray [ 1] := BtnOpen;
    BTNsArray [ 2] := Bevel1;
    BTNsArray [ 3] := BtnAdd;
    BTNsArray [ 4] := BtnExtract;
    BTNsArray [ 5] := BtnView;
    BTNsArray [ 6] := BtnDelete;
    BTNsArray [ 7] := Bevel2;
    BTNsArray [ 8] := BtnTest;
    BTNsArray [ 9] := BtnInfo;
    BTNsArray [10] := BtnCheckOut;
    BTNsArray [11] := Bevel3;
    BTNsArray [12] := BtnHelp;
    BTNsArray [13] := BtnExit;

    UpdateDetail (-1);
    UpdateStyle (-1);
    UpdateBtns;

    MainFrm_ArcName := '';
    MainFrm_ArcInfo := TBGInfo.Create;
    MainFrm_ParamS  := TStringList.Create;

    myLoadBtnsSkin (BTNsArray);
    ProcessOpening (False);
  end;

  procedure TMainFrm.FormCloseQuery (Sender: TObject; var CanClose: Boolean);
  begin
    if (MainFrm.Cursor = crHourGlass) then
      CanClose := MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_Terminate_Process], mtWarning, [mbYes, mbNo], 0) = mrYes;
  end;

  procedure TMainFrm.FormClose (Sender: TObject; var Action: TCloseAction);
  begin
    if (MainFrm.Cursor = crHourGlass) then MainFrm_Process.Terminate;
    if MainFrm_MainMenu_Options_SaveOnExit.Checked then Save (True);

    if DirectoryExists (ReturnCheckOutDir) then
      if MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_delete_checkout], mtInformation, [mbYes, mbNo], 0) = mrYes then
        DeleteCheckOutDir;

    if DirectoryExists (ReturnTempDir) then
      DeleteTempDir;
  end;

  procedure TMainFrm.FormResize (Sender: TObject);
  begin
    MainFrm_ProgressBar.Parent := MainFrm_StatusBar;
    MainFrm_StatusBar.Panels [0].Width := MainFrm.Width * 2 div 3;
  end;


  
  //------------------------------------------------------//
  //                                                      //
  // TMainFrm  private function and procedures            //
  //                                                      //
  //------------------------------------------------------//

  procedure TMainFrm.UpdateOrder;
  var
    I: integer;
  begin
    if (by > -1) and (by < MainFrm_MainMenu_View_OrderBy.Count) then
    begin
      for I := 0 to MainFrm_MainMenu_View_OrderBy.Count -1 do
      begin
        MainFrm_MainMenu_View_OrderBy.Items [I].Checked := False;
        MainFrm_PopupMenu_OrderBy.Items [I].Checked := False;
      end;
      MainFrm_MainMenu_View_OrderBy.Items [by].Checked :=True;
      MainFrm_PopupMenu_OrderBy.Items [by].Checked := True;
      MainFrm_ListView.ColumnSort := by;
    end;
  end;

  procedure TMainFrm.UpdateDetail;
  var
    I: integer;
  begin
    if (index > -1) and (index < MainFrm_MainMenu_View_Details.Count) then
      MainFrm_MainMenu_View_Details.Items [index].Checked := not MainFrm_MainMenu_View_Details.Items [index].Checked;

    for I := 0 to MainFrm_MainMenu_View_Details.Count -1 do
    begin
      MainFrm_PopupMenu_Details.Items [I].Checked := MainFrm_MainMenu_View_Details.Items [I].Checked;

      if MainFrm_MainMenu_View_Details.Items [I].Checked then
      begin
        if MainFrm_ListView.Columns [I].Width < 20 then
        begin
          MainFrm_ListView.Columns [I].MaxWidth :=  0;
          MainFrm_ListView.Columns [I].MinWidth :=  0;
          MainFrm_ListView.Columns [I].Width    := 60;
        end;
      end else
      begin
        MainFrm_ListView.Columns [I].MaxWidth := 1;
        MainFrm_ListView.Columns [I].MinWidth := 0;
        MainFrm_ListView.Columns [I].Width    := 0;
      end;
    end;
  end;

  procedure  TMainFrm.UpdateStyle;
  var
    I: integer;
  begin
    if (index > 2) and (index < 7) then
    begin
      for I := 3 to 6 do
        if I = index then
          MainFrm_MainMenu_View.Items [I].Checked := True
        else
          MainFrm_MainMenu_View.Items [I].Checked := False;
    end;

    for I := 3 to 6 do
      if MainFrm_MainMenu_View.Items [I].Checked then index := I;

    if index = 3 then MainFrm_ListView.ViewStyle := vsIcon;
    if index = 4 then MainFrm_ListView.ViewStyle := vsSmallIcon;
    if index = 5 then MainFrm_ListView.ViewStyle := vsList;
    if index = 6 then MainFrm_ListView.ViewStyle := vsReport;
  end;

  procedure TMainFrm.UpdateBtns;
  const
    TopMargin  =  4;
    LeftMargin =  4;
  var
    I: integer;
    TopPos: integer;
    LeftPos: integer;
  begin
    TopPos  := TopMargin;
    LeftPos := LeftMargin;

    for I := 0 to BTNsCount - 1 do
      BTNsArray [I].Visible := MainFrm_PopupMenu_Btns.Items [I].Checked;

    for I := 0 to BtnsCount - 1 do
    begin
      BTNsArray [I].Top  := TopPos;
      BTNsArray [I].Left := LeftPos;
      if BTNsArray [I].Visible then
        Inc (LeftPos, LeftMargin + BTNsArray [I].Width);
    end;

    if not (LeftPos = LeftMargin) then
      Inc (TopPos, TopMargin + BTNsArray [0].Height);

    MainFrm_StatusBar.Visible  := MainFrm_MainMenu_View_StatusBar.Checked;

    if MainFrm_MainMenu_View_ListMode.Checked then
      MainFrm_MainMenu_View_ToolBar_AddressBar.Enabled := False
    else
      MainFrm_MainMenu_View_ToolBar_AddressBar.Enabled := True;

    with MainFrm_MainMenu_View_ToolBar_AddressBar do BtnUp.Visible := Checked and Enabled;
    MainFrm_PathBox.Visible := BtnUp.Visible;

    MainFrm_ListView.RowSelect := MainFrm_MainMenu_View_RowSelect.Checked;
    MainFrm_ListView.GridLines := MainFrm_MainMenu_View_GridLines.Checked;
    MainFrm_ListView.ListMode  := MainFrm_MainMenu_View_ListMode.Checked;

    MainFrm_Bevel.Top     := TopPos;
    MainFrm_Bevel.Visible := (not (LeftPos = LeftMargin)) and (BtnUp.Visible);
    if MainFrm_Bevel.Visible then Inc (TopPos, TopMargin + MainFrm_Bevel.Height);

    BtnUp.Top           := TopPos;
    MainFrm_PathBox.Top := TopPos;
    if MainFrm_PathBox.Visible then Inc (TopPos, TopMargin + MainFrm_PathBox.Height);

    MainFrm_ButtonsPanel.Height := TopPos;

    if not (MainFrm_ButtonsPanel.Height = TopMargin) then
      MainFrm_ButtonsPanel.Visible := True
    else
      MainFrm_ButtonsPanel.Visible := False;
  end;

  procedure TMainFrm.UpdateCursor;
  begin
    MainFrm.Cursor := Value;
    MainFrm_PathBox.Cursor := Value;
    MainFrm_ListView.Cursor := Value;
  end;



  // ---------------------------------------------------------- //
  //                                                            //
  // TMainFrm Event procedures                                  //
  //                                                            //
  // ---------------------------------------------------------- //

  procedure TMainFrm.OnRename;
  var
    f: TRenameFrm;
  begin
    f := TRenameFrm.Create (Self);
    f.Caption := MainFrm_MSGs.Items [MSG_rename_file];
    f.RenameFrm_To.Text := Mainfrm_Process.OnReNameREC.OldName;
    if (f.ShowModal = mrOk) and (CompareText (f.RenameFrm_From.Caption, f.RenameFrm_To.Text) <> 0) and (Length (f.RenameFrm_To.Text) > 0) then
      Mainfrm_Process.OnReNameREC.Result := f.RenameFrm_To.Text;
    f.Destroy;
  end;

  procedure TMainFrm.OnOverWrite;
  var
    f: TOverWriteFrm;
    ImageIndex: integer;
  begin
    f := TOverWriteFrm.Create (Self);
    with Mainfrm_Process.OnOverWriteREC do
    begin
      f.OverWriteFrm_OldSize.Caption := f.OverWriteFrm_OldSize.Caption + '  ' + SizeToStr (OSize);
      f.OverWriteFrm_NewSize.Caption := f.OverWriteFrm_NewSize.Caption + '  ' + IntToStr (NSize);
      f.OverWriteFrm_OldDate.Caption := f.OverWriteFrm_OldDate.Caption + '  ' + DateTimeToStr (FileDateToDateTime (OTime));
      f.OverWriteFrm_NewDate.Caption := f.OverWriteFrm_NewDate.Caption + '  ' + DateTimeToStr (FileDateToDateTime (NTime));
      f.OverWriteFrm_The.Caption     := f.OverWriteFrm_The.Caption     + ' "' + FileName + '".';

      ImageIndex := BG_GetFileImageIndex (FileName, faArchive);
      MainFrm_ListView.LargeImages.GetBitmap (ImageIndex, f.OverWriteFrm_OldImage.Picture.Bitmap);
      MainFrm_ListView.LargeImages.GetBitmap (ImageIndex, f.OverWriteFrm_NewImage.Picture.Bitmap);

      case f.ShowModal of
        mrAbort    : Result := 'Q'; // Quit
        mrNoToAll  : Result := 'S'; // SkipAll
        mrYesToAll : Result := 'A'; // YesAll
        mrNo       : Result := 'N'; // No
        mrYes      : Result := 'Y'; // Yes
      end;
    end;
    f.Destroy;
  end;

  procedure TMainFrm.OnWarning;
  begin
    if not Assigned (MainFrm_Process_Log) then MainFrm_Process_Log := TStringList.Create;
    MainFrm_Process_Log.Add (Mainfrm_Process.OnMsgREC);

    MessageDlg (Application.Title + ': ' + Mainfrm_Process.OnMsgREC, mtWarning, [mbOk], 0);
  end;

  procedure TMainFrm.OnError;
  begin
    if not Assigned (MainFrm_Process_Log) then MainFrm_Process_Log := TStringList.Create;
    MainFrm_Process_Log.Add (Mainfrm_Process.OnMsgREC);

    MessageDlg (Application.Title + ': ' + Mainfrm_Process.OnMsgREC, mtError, [mbOk], 0);
  end;

  procedure TMainFrm.OnDisplayLog;
  begin
    if not Assigned (MainFrm_Process_Log) then MainFrm_Process_Log := TStringList.Create;
    MainFrm_Process_Log.Add (Mainfrm_Process.OnMsgREC);

    MainFrm_StatusBar.Panels [0].Text := Mainfrm_Process.OnMsgREC;
  end;

  procedure TMainFrm.OnDisplay;
  begin
    MainFrm_StatusBar.Panels [0].Text := Mainfrm_Process.OnMsgREC;
  end;

  procedure TMainFrm.OnList;
  begin
    Mainfrm_Process.OnListREC.ResultL := MainFrm_ListView.Files;
    Mainfrm_Process.OnListREC.ResultI := MainFrm_ArcInfo;
  end;

  procedure TMainFrm.OnTick;
  begin
    MainFrm_ProgressBar.Position := Mainfrm_Process.OnPercentageREC;
  end;

  // Process

  procedure TMainFrm.StartProcess;
  begin
    ProcessOpening (False);
    UpdateCursor   (crHourGlass);

    // Create process
    MainFrm_Process := TBeeApp.Create (MainFrm_ParamS);

    // Assign Events
    MainFrm_Process.OnList      := MainFrm.OnList;
    MainFrm_Process.OnTick      := MainFrm.OnTick;
    MainFrm_Process.OnRename    := MainFrm.OnRename;
    MainFrm_Process.OnOverWrite := MainFrm.OnOverWrite;
    MainFrm_Process.OnTerminate := MainFrm.OnTerminate;

    MainFrm_Process.OnError     := MainFrm.OnError;
    MainFrm_Process.OnWarning   := MainFrm.OnWarning;

    if CreateLog then
      MainFrm_Process.OnDisplay := MainFrm.OnDisplayLog
    else
      MainFrm_Process.OnDisplay := MainFrm.OnDisplay;

    // Set Priority Process
    MainFrm_Process.Priority    := SetPriority (MainFrm_Process_Priority);

    // Resume process
    MainFrm_Process.Resume;
  end;

  procedure TMainFrm.OnTerminate;
  begin
    MainFrm_ListView.Initialize;
    ProcessActionLog;

    case MainFrm_Process_Action of
      paView    : ProcessActionView (MainFrm_ParamS.Strings [3]);
    end;

    UpdateCursor (crDefault);

    ProcessOpening (True);
    MainFrm_ListViewClick (Self);

    case MainFrm_Process_Action of
      paNew     : ProcessActionNew;
      paCheckOut: ProcessActionCheckOut;
    end;
  end;


  
  // ---------------------------------------------------------------------- //
  //                                                                        //
  // TMainFrom Process procedures                                           //
  //                                                                        //
  // ---------------------------------------------------------------------- //

  function TMainFrm.ProcessFiles;
  var
    I: integer;
    Node: TListItem;
  begin
    Result := 0;
    for I := 0 to MainFrm_ListView.Items.Count -1 do
      if MainFrm_ListView.Items [I].Selected then
      begin
        Node := MainFrm_ListView.Items [I];
        if Length (Node.SubItems [PosCol]) = 0 then //  if Directory
          ParamS.Add (Node.SubItems [PathCol] + Node.Caption + DoDelimiter ('\*\*.*'))
        else
          ParamS.Add (Node.SubItems [PathCol] + Node.Caption);
        Inc (Result);
      end;
  end;

  procedure TMainFrm.ProcessOpening;
  var
    I: integer;
  begin
    with MainFrm_MainMenu_File    do for I := 2 to 9        do Items [I].Enabled := Value;
    with MainFrm_MainMenu_Actions do for I := 0 to Count -1 do Items [I].Enabled := Value;

    try
      for I := 3 to BtnsCount -4 do
      begin
        if BTNsArray [I].ClassType = TSpeedButton then
          TSpeedButton (BTNsArray [I]).Enabled := Value;
      end;

      BtnUp.Enabled            := Value;
      MainFrm_PathBox.Enabled  := Value;
      MainFrm_ListView.Enabled := Value;

      if Value then
        MainFrm_PathBox.Color  := clWindow
      else
        MainFrm_PathBox.Color  := clInactiveCaptionText;
      MainFrm_ListView.Color :=  MainFrm_PathBox.Color;
    except
      MessageDlg (Application.Title + ': ' + 'on Graphic User Interface.', mtError, [mbOk], 0);
    end;
  end;

  procedure TMainFrm.ProcessActionNew;
  begin
    MainFrm_MainMenu_Actions_Add.Click;
  end;

  procedure TMainFrm.ProcessActionView;
  var
    f: TIntViewerFrm;
    e: TChoiseViewerFrm;
  begin
    if FileExists (FileName) then
    begin
      e := TChoiseViewerFrm.Create (Self);
      try
        if e.ShowModal = mrOk then
        begin
          if e.ChoiseViewerFrm_IntViewer.Checked then
          begin
            f := TIntViewerFrm.Create (Self);
            f.IntViewerFrm_Viewer.Lines.LoadFromFile (MainFrm_ParamS.Strings [3]);
            f.ShowModal;
            f.Destroy;
          end else
            BG_ShellExecute (MainFrm_ParamS.Strings [3], '');
        end;
      finally
        e.Destroy;
      end;
    end;
  end;

  procedure TMainFrm.ProcessActionLog;
  var
    f: TIntViewerFrm;
  begin
    if Assigned (MainFrm_Process_Log) then
    begin
      if not (MainFrm_Process_Log.Count = 0) then
      begin
        f := TIntViewerFrm.Create (Self);
        f.IntViewerFrm_Viewer.Lines.AddStrings (MainFrm_Process_Log);
        f.ShowModal;
        f.Destroy;
      end;
      FreeAndNil (MainFrm_Process_Log);
    end;
  end;

  procedure TMainFrm.ProcessActionCheckOut;
  begin
    BG_ShellExecute (GetCurrentDir, '');
  end;



  // ----------------------------------------------------------------------------- //
  //                                                                               //
  // TMainFrm StatusBar                                                            //
  //                                                                               //
  // ----------------------------------------------------------------------------- //

  procedure TMainFrm.MainFrm_StatusBarDrawPanel (StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
  begin
    if Panel.Index = 1 then
      with MainFrm_ProgressBar do
      begin
        Visible := True;
        Left    := Rect.Left - 1;
        Top     := Rect.Top  - 1;
        Height  := (Rect.Bottom - Rect.Top ) +  2;
        Width   := (Rect.Right  - Rect.Left) - 14;
      end;
  end;

  procedure TMainFrm.MainFrm_StatusBarResize(Sender: TObject);
  begin
    MainFrm_StatusBar.Panels [0].Width := (MainFrm.Width * 2 div 3);
  end;



  // ------------------------------------------------------------------------------ //
  //                                                                                //
  // MainFrm MainMenu_File Click                                                    //
  //                                                                                //
  // ------------------------------------------------------------------------------ //

  procedure TMainFrm.MainFrm_MainMenu_File_NewClick (Sender: TObject);
  begin
    if MainFrm.Cursor = crDefault then
    begin
      MainFrm_SaveDialog.FileName := '';
      if MainFrm_SaveDialog.Execute then
      begin
        MainFrm_MainMenu_File_Close.Click;
        MainFrm_ArcName := MainFrm_SaveDialog.FileName;

        case MainFrm_SaveDialog.FilterIndex of
          1: MainFrm_ArcName := ChangeFileExt (MainFrm_ArcName, '.bee');
        end;

        Caption := Application.Title + ' - ' + ExtractFileName (MainFrm_ArcName);
        MainFrm_ListView.PathBoxSign := ExtractFileName (MainFrm_ArcName) + Delimiter;

        MainFrm_ParamS.Clear;
        MainFrm_ParamS.Add ('l');
        MainFrm_ParamS.Add (MainFrm_ArcName);
        MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

        MainFrm_Process_Action   := paNew;
        MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);
        
        StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);
      end;
    end else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_process], mtInformation, [mbOk], 0);
  end;
  
  procedure TMainFrm.MainFrm_MainMenu_File_OpenClick (Sender: TObject);
  begin
    if MainFrm.Cursor = crDefault then
    begin
      MainFrm_OpenDialog.FileName := '';
      if MainFrm_OpenDialog.Execute then
      begin
        MainFrm_MainMenu_File_Close.Click;
        MainFrm_ArcName := MainFrm_OpenDialog.FileName;
        
        Caption := Application.Title + ' - ' + ExtractFileName (MainFrm_ArcName);
        MainFrm_ListView.PathBoxSign := ExtractFileName (MainFrm_ArcName) + Delimiter;

        MainFrm_ParamS.Clear;
        MainFrm_ParamS.Add ('l');
        MainFrm_ParamS.Add (MainFrm_ArcName);
        MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

        MainFrm_Process_Action   := paDefault;
        MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);
        
        StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);
      end;
    end else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_process], mtInformation, [mbOk], 0);
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_CloseClick (Sender: TObject);
  begin
    MainFrm_StatusBar.Panels [0].Text := '';
    SetLength (MainFrm_ArcName, 0);
    Caption := Application.Title;
    MainFrm_ListView.Clear;
    MainFrm_PathBox.Clear;
    MainFrm_ParamS.Clear;
    
    ProcessOpening (False);
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_MoveClick (Sender: TObject);
  var
    moveto: string;
    newname: string;
  begin
    SetLength (moveto, 0);
    SelectDirectory (MainFrm_MSGs.Items [MSG_moveto], '', moveto);

    if not (Length (moveto) = 0) then
    begin
      newname := IncludeDelimiter (moveto) + ExtractFileName (MainFrm_ArcName);
      if RenameFile (MainFrm_ArcName, newname) then
      begin
        MainFrm_MainMenu_File_Close.Click;
        MainFrm_ArcName := newname;

        Caption := Application.Title + ' - ' + ExtractFileName (MainFrm_ArcName);
        MainFrm_ListView.PathBoxSign := ExtractFileName (MainFrm_ArcName) + Delimiter;

        MainFrm_ParamS.Clear;
        MainFrm_ParamS.Add ('l');
        MainFrm_ParamS.Add (MainFrm_ArcName);
        MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

        MainFrm_Process_Action   := paDefault;
        MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);
        
        StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);
      end else
        MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_moveto_error], mtError, [mbOk], 0);
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_InfoClick (Sender: TObject);
  var
    f: TInfoFrm;
  begin
    f := TInfoFrm.Create (Self);
    try
      if f.UpdateInfo (MainFrm_ArcInfo) then
        f.ShowModal
      else
        MessageDlg (Application.Title + ': ' + 'Can''t load archive infomations.', mtInformation, [mbOk], 0);
    finally
      f.Destroy;
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_CopyClick (Sender: TObject);
  var
    copyto: string;
    newname: string;
  begin
    SetLength (copyto, 0);
    SelectDirectory (MainFrm_MSGs.Items [MSG_copyto], '', copyto);

    if not (Length (copyto) = 0) then
    begin
      newname := IncludeDelimiter (copyto) + ExtractFileName (MainFrm_ArcName);
      if CopyFile (PChar (MainFrm_ArcName), PChar (newname), True) then
      begin
        MainFrm_MainMenu_File_Close.Click;
        MainFrm_ArcName := newname;

        Caption := Application.Title + ' - ' + ExtractFileName (MainFrm_ArcName);
        MainFrm_ListView.PathBoxSign := ExtractFileName (MainFrm_ArcName) + Delimiter;

        MainFrm_ParamS.Clear;
        MainFrm_ParamS.Add ('l');
        MainFrm_ParamS.Add (MainFrm_ArcName);
        MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

        MainFrm_Process_Action   := paDefault;
        MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);
        
        StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);
      end else
        MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_copyto_error], mtError, [mbOk], 0);
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_RenameClick (Sender: TObject);
  var
    f: TRenameFrm;
    newname: string;
  begin
    f := TRenameFrm.Create (Self);
    f.Caption := MainFrm_MSGs.Items [MSG_rename_arc];
    f.RenameFrm_To.Text := ExtractFileName (MainFrm_ArcName);

    if f.ShowModal = mrOk then
    begin
      if  (CompareText (f.RenameFrm_From.Caption, f.RenameFrm_To.Text) <> 0) and (Length (f.RenameFrm_To.Text) > 0) then
      begin
        newname := ExtractFilePath (MainFrm_ArcName) + f.RenameFrm_To.Text;
        if RenameFile (MainFrm_ArcName, newname) then
        begin
          MainFrm_MainMenu_File_Close.Click;
          MainFrm_ArcName := newname;

          Caption := Application.Title + ' - ' + ExtractFileName (MainFrm_ArcName);
          MainFrm_ListView.PathBoxSign := ExtractFileName (MainFrm_ArcName) + Delimiter;

          MainFrm_ParamS.Clear;
          MainFrm_ParamS.Add ('l');
          MainFrm_ParamS.Add (MainFrm_ArcName);
          MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

          MainFrm_Process_Action   := paDefault;
          MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);
          
          StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);
        end else
          MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_rename_arc_error], mtError, [mbOk], 0);
      end;
    end;
    f.Destroy;
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_DeleteClick (Sender: TObject);
  begin
    if MessageDlg (MainFrm_MSGs.Items [MSG_delete] + ExtractFileName (MainFrm_ArcName), mtInformation, [mbYes, mbNo], 0) = mrYes then
    begin
      if DeleteFile (MainFrm_ArcName) then
        MainFrm_MainMenu_File_Close.Click
      else
        MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_delete_error], mtError, [mbOk], 0);
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_File_ExitClick (Sender: TObject);
  begin
    Close;
  end;



  // ------------------------------------------------------------------------------------- //
  //                                                                                       //
  // TMainFrm MainFrm_MainMenu_View_ToolBar_Btns Click                                     //
  //                                                                                       //
  // ------------------------------------------------------------------------------------- //

  procedure TMainFrm.MainFrm_MainMenu_View_ToolBar_BtnsClick (Sender: TObject);
  var
    f: TConfigFrm;
    s1, s2: string;
  begin
    f := TConfigFrm.Create (Self);
    f.ConfigFrm_Notebook.PageIndex := 2;
    f.ConfigFrm_Tree.Items [2].Selected := True;
    f.Set_Btns_PopupMenu (MainFrm_PopupMenu_Btns);    

    s1 := f.ConfigFrm_Skin_SelectCB.Text;
    case f.ShowModal of
      mrCancel: f.Destroy;
      mrOk    : begin
                  f.Get_Btns_PopupMenu;

                  s2 := f.ConfigFrm_Skin_SelectCB.Text;
                  f.SaveAndDestroy;
                  if not (CompareStr (s1, s2) = 0) then
                    myLoadBtnsSkin (BTNsArray);

                  UpdateBtns;
                end;
    end;
  end;



  // ------------------------------------------------------------------------------------- //
  //                                                                                       //
  // TMainFrm MainFrm_MainMenu_View_ToolBar Click                                          //
  //                                                                                       //
  // ------------------------------------------------------------------------------------- //

  procedure TMainFrm.MainFrm_MainMenu_View_ToolBar_AddressBarClick ( Sender: TObject);
  begin
    MainFrm_MainMenu_View_ToolBar_AddressBar.Checked := not MainFrm_MainMenu_View_ToolBar_AddressBar.Checked;
    UpdateBtns;
  end;

  procedure TMainFrm.MainFrm_MainMenu_View_StatusBarClick (Sender: TObject);
  begin
    MainFrm_MainMenu_View_StatusBar.Checked := not MainFrm_MainMenu_View_StatusBar.Checked;
    UpdateBtns;
  end;

  procedure TMainFrm.MainFrm_MainMenu_View_RowSelectClick (Sender: TObject);
  begin
    MainFrm_MainMenu_View_RowSelect.Checked := not MainFrm_MainMenu_View_RowSelect.Checked;
    UpdateBtns;
  end;

  procedure TMainFrm.MainFrm_MainMenu_View_GridLinesClick (Sender: TObject);
  begin
    MainFrm_MainMenu_View_GridLines.Checked := not MainFrm_MainMenu_View_GridLines.Checked;
    UpdateBtns;
  end;

  procedure TMainFrm.MainFrm_MainMenu_View_ListModeClick (Sender: TObject);
  begin
    MainFrm_MainMenu_View_ListMode.Checked := not MainFrm_MainMenu_View_ListMode.Checked;
    UpdateBtns;
  end;

  procedure TMainFrm.MainFrm_MainMenu_View_IconsClick      (Sender: TObject); begin  UpdateStyle (3); end;
  procedure TMainFrm.MainFrm_MainMenu_View_SmallIconsClick (Sender: TObject); begin  UpdateStyle (4); end;
  procedure TMainFrm.MainFrm_MainMenu_View_ListClick       (Sender: TObject); begin  UpdateStyle (5); end;
  procedure TMainFrm.MainFrm_MainMenu_View_ReportClick     (Sender: TObject); begin  UpdateStyle (6); end;



  // ------------------------------------------------------------------ //
  //                                                                    //
  // TMainFrm MainFrm_MainMenu_View_OrderBy Click                       //
  //                                                                    //
  // ------------------------------------------------------------------ //

  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_NameClick       (Sender: TObject); begin UpdateOrder ( 0); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_TypeClick       (Sender: TObject); begin UpdateOrder ( 1); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_PackedClick     (Sender: TObject); begin UpdateOrder ( 2); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_SizeClick       (Sender: TObject); begin UpdateOrder ( 3); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_RatioClick      (Sender: TObject); begin UpdateOrder ( 4); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_MethodClick     (Sender: TObject); begin UpdateOrder ( 5); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_ModifiedClick   (Sender: TObject); begin UpdateOrder ( 6); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_AttributesClick (Sender: TObject); begin UpdateOrder ( 7); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_CRCClick        (Sender: TObject); begin UpdateOrder ( 8); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_PathClick       (Sender: TObject); begin UpdateOrder ( 9); end;
  procedure TMainFrm.MainFrm_MainMenu_View_OrderBy_PositionClick   (Sender: TObject); begin UpdateOrder (10); end;

  procedure TMainFrm.MainFrm_ListViewColumnClick (Sender: TObject; Column: TListColumn);
  begin
    UpdateOrder (Column.Index);
  end;



  // ------------------------------------------------------------------ //
  //                                                                    //
  // TMainFrm MainFrm_MainMenu_View_Details Click                       //
  //                                                                    //
  // ------------------------------------------------------------------ //

  procedure TMainFrm.MainFrm_MainMenu_View_Details_NameClick       (Sender: TObject); begin UpdateDetail ( 0); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_TypeClick       (Sender: TObject); begin UpdateDetail ( 1); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_PackedClick     (Sender: TObject); begin UpdateDetail ( 2); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_SizeClick       (Sender: TObject); begin UpdateDetail ( 3); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_RatioClick      (Sender: TObject); begin UpdateDetail ( 4); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_MethodClick     (Sender: TObject); begin UpdateDetail ( 5); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_ModifiedClick   (Sender: TObject); begin UpdateDetail ( 6); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_AttributesClick (Sender: TObject); begin UpdateDetail ( 7); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_CRCClick        (Sender: TObject); begin UpdateDetail ( 8); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_PathClick       (Sender: TObject); begin UpdateDetail ( 9); end;
  procedure TMainFrm.MainFrm_MainMenu_View_Details_PositionClick   (Sender: TObject); begin UpdateDetail (10); end;



  // -------------------------------------------------------------------- //
  //                                                                      //
  // TMainFrm MainMenu_Action Click;                                      //
  //                                                                      //
  // -------------------------------------------------------------------- //

  procedure TMainFrm.MainFrm_MainMenu_Actions_AddClick (Sender: TObject);
  var
    I: integer;
    f: TAddFrm;
    oState: TWindowState;
  begin
    f := TAddFrm.Create (Self);
    f.AddFrm_cOption.Enabled := not MainFrm_MainMenu_View_ListMode.Checked;

    oState := MainFrm.WindowState;
    if GetBoolValue (HIDEMAINFRM_CLASS, HIDEMAINFRM_IDENT, True) then
      MainFrm.WindowState := wsMinimized;

    if f.ShowModal = mrOk then
    begin
      MainFrm.WindowState := oState;

      if MainFrm.Cursor = crDefault then
      begin
        if not (f.AddFrm_FilesList.Items.Count = 0) then
        begin
          MainFrm_ParamS.Clear;                                                                   // Clear cmd line
          MainFrm_ParamS.Add ('a');                                                               // Command
          case f.AddFrm_Action.ItemIndex of
           0: MainFrm_ParamS.Add ('-f');
           1: MainFrm_ParamS.Add ('-u');
          end;

          if f.AddFrm_rOption.Checked then MainFrm_ParamS.Add ('-r');                             // Options
          if f.AddFrm_pOption.Checked then MainFrm_ParamS.Add ('-p');
          if f.AddFrm_sOption.Checked then MainFrm_ParamS.Add ('-s');
          if f.AddFrm_tOption.Checked then MainFrm_ParamS.Add ('-t');

          MainFrm_ParamS.Add ('-m'   + IntToStr (f.AddFrm_Method       .ItemIndex));
          MainFrm_ParamS.Add ('-d'   + IntToStr (f.AddFrm_Dictionary   .ItemIndex));
          MainFrm_ParamS.Add ('-e'   +           f.AddFrm_eOption.Text            );

          if f.AddFrm_cOption.Enabled and f.AddFrm_cOption.Checked then
            MainFrm_ParamS.Add ('-c' + MainFrm_ListView.CurrDir);

          MainFrm_ParamS.Add (MainFrm_ArcName);                                                   // Archive

          for I := 0 to f.AddFrm_FilesList.Items.Count - 1 do                                     // Files selected and excluded
            if f.AddFrm_FilesList.Items [I].ImageIndex = S_Index then
              MainFrm_ParamS.Add (f.AddFrm_FilesList.Items [I].Caption)
            else
              MainFrm_ParamS.Add ('-x' + f.AddFrm_FilesList.Items [I].Caption);

          MainFrm_Process_Action   := paDefault;
          MainFrm_Process_Priority := f.ConfigFrm_Priority.ItemIndex;

          if (Length (f.AddFrm_Root.Text) = 0) or SetCurrentDir (f.AddFrm_Root.Text) then
            StartProcess (MainFrm_MainMenu_Options_LogReport.Checked or f.AddFrm_tOption.Checked) // Process ParamS
          else
            MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_set_cur_dir], mtError, [mbOk], 0);
        end else
          MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_no_files_selected], mtWarning, [mbOk], 0);
      end else
        MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_process], mtInformation, [mbOk], 0);
    end else
      MainFrm.WindowState := oState;
      
    f.Destroy;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_DeleteClick(Sender: TObject);
  begin
    if not (MainFrm_ListView.Selected = nil) then
    begin
      if MessageDlg (MainFrm_MSGs.Items [MSG_delete_files] , mtInformation, [mbYes, mbNo], 0) = mrYes then
      begin
        MainFrm_ParamS.Clear;                                          // Clear cmd line
        MainFrm_ParamS.Add ('d');                                      // Command
        MainFrm_ParamS.Add (MainFrm_ArcName);                          // Archive
        ProcessFiles (MainFrm_ParamS);                                 // Files selected

        MainFrm_Process_Action   := paDefault;
        MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);

        StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);     // Process ParamS
      end;
    end else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_no_files_selected], mtWarning, [mbOk], 0);
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_ExtractClick (Sender: TObject);
  var
    f: TExtractFrm;
  begin
    f := TExtractFrm.Create (Self);
    f.ExtractFrm_Tree.Images := MainFrm_ListView.SmallImages;
    f.ExtractFrm_cOption.Enabled := not MainFrm_MainMenu_View_ListMode.Checked;

    if f.ShowModal = mrOK then
    begin
      MainFrm_ParamS.Clear;                                     // Clear cmd line
      case f.ExtractFrm_ExtrDirName.Checked of                  // Command
        true : MainFrm_ParamS.Add ('x');
        false: MainFrm_ParamS.Add ('e');
      end;
      case f.ExtractFrm_ExtrOverWrite.ItemIndex of              // Options
        0: MainFrm_ParamS.Add ('-oS');
        1: MainFrm_ParamS.Add ('-oA');
      end;

      if f.ExtractFrm_cOption.Enabled and f.ExtractFrm_cOption.Checked then
        MainFrm_ParamS.Add ('-c' + MainFrm_ListView.CurrDir);

      MainFrm_ParamS.Add (MainFrm_ArcName);                       // Archive

      if ProcessFiles (MainFrm_ParamS) = 0 then                   // Files selected
        MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

      ForceDirectories (f.ExtractFrm_ExtrDir.Text);

      MainFrm_Process_Action   := paDefault;
      MainFrm_Process_Priority := f.ConfigFrm_Priority.ItemIndex;

      if SetCurrentDir (f.ExtractFrm_ExtrDir.Text) then
        StartProcess (MainFrm_MainMenu_Options_LogReport.Checked) // Process ParamS
      else
        MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_set_cur_dir], mtError, [mbOk], 0);
    end;
    f.Destroy;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_ExtractAllClick (Sender: TObject);
  var
    f: TSeDeseFrm;
  begin
    f := TSeDeseFrm.Create (Self);
    f.DeSelectAll (MainFrm_ListView);
    f.Destroy;

    MainFrm_MainMenu_Actions_Extract.Click;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_TestClick(Sender: TObject);
  begin
    MainFrm_ParamS.Clear;
    MainFrm_ParamS.Add ('t');                                   // Command
    MainFrm_ParamS.Add (MainFrm_ArcName);                       // Archive

    if ProcessFiles (MainFrm_ParamS) = 0 then                   // Files selected
      MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));

    MainFrm_Process_Action   := paDefault;
    MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);

    StartProcess (True);                                        // Process ParamS
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_RenameClick (Sender: TObject);
  begin
    if not (MainFrm_ListView.Selected = nil) then
    begin
      MainFrm_ParamS.Clear;                                       // Clear cmd line
      MainFrm_ParamS.Add ('r');                                   // Command
      MainFrm_ParamS.Add (MainFrm_ArcName);                       // Archive
      ProcessFiles (MainFrm_ParamS);                              // Files selected

      MainFrm_Process_Action   := paDefault;
      MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);

      StartProcess (MainFrm_MainMenu_Options_LogReport.Checked);  // Process ParamS
    end else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_no_files_selected], mtWarning, [mbOk], 0);
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_ViewClick (Sender: TObject);
  begin
    if not (MainFrm_ListView.Selected = nil) then
    begin
      if Length (MainFrm_ListView.Selected.SubItems [PosCol]) = 0 then
      begin
        MainFrm_ListView.CurrDir := MainFrm_PathBox.Items [MainFrm_PathBox.ItemIndex] + MainFrm_ListView.Selected.Caption + Delimiter;
        MainFrm_ListViewClick (Self);
        MainFrm_ListView.SetFocus;
      end else
      begin
        MainFrm_ParamS.Clear;                                   // Clear cmd line
        MainFrm_ParamS.Add ('x');
        MainFrm_ParamS.Add ('-oA');
        MainFrm_ParamS.Add (MainFrm_ArcName);                   // Archive
        ProcessFiles (MainFrm_ParamS);                          // Files selected

        CreateDir (ReturnTempDir);

        MainFrm_Process_Action   := paView;
        MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);

        if SetCurrentDir (ReturnTempDir) then
          StartProcess (MainFrm_MainMenu_Options_LogReport.Checked)
        else
          MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_set_cur_dir], mtError, [mbOk], 0);
      end;
    end else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_no_files_selected], mtWarning, [mbOk], 0);
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_CheckOutClick (Sender: TObject);
  begin
    DeleteCheckOutDir;
    MainFrm_ParamS.Clear;                                       // Clear cmd line
    MainFrm_ParamS.Add ('x');
    MainFrm_ParamS.Add ('-oA');
    MainFrm_ParamS.Add (MainFrm_ArcName);                       // Archive
    MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));                 // Files selected

    CreateDir (ReturnCheckOutDir);

    MainFrm_Process_Action   := paCheckOut;
    MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);
    
    if SetCurrentDir (ReturnCheckOutDir) then
      StartProcess (MainFrm_MainMenu_Options_LogReport.Checked)
    else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_checkout_error], mtError, [mbOk], 0);
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_TestAllClick (Sender: TObject);
  begin
    MainFrm_ParamS.Clear;
    MainFrm_ParamS.Add ('t');                                   // Command
    MainFrm_ParamS.Add (MainFrm_ArcName);                       // Archive
    MainFrm_ParamS.Add (DoDelimiter ('*\*.*'));                 // Command

    MainFrm_Process_Action   := paDefault;
    MainFrm_Process_Priority := GetIntegerValue (PPriority_CLASS, PPriority_Ident, True);

    StartProcess (True);                                        // Process ParamS
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_SelectAllClick (Sender: TObject);
  var
    f: TSeDeseFrm;
  begin
    try
      MainFrm_ListView.SetFocus;
    finally
      f := TSeDeseFrm.Create (Self);
      f.SelectAll (MainFrm_ListView);
      f.Destroy;
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_SelectMaskClick (Sender: TObject);
  var
    f: TSeDeseFrm;
  begin
    try
      MainFrm_ListView.SetFocus;
    finally
      f := TSeDeseFrm.Create (Self);
      f.Caption := f.SeDeSeFrm_FrmCaptionCB.Items [0];
      if f.ShowModal = mrOk then
        f.SelectItems (MainFrm_ListView);
      f.Destroy;
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_DeselectMasksClick (Sender: TObject);
  var
    f: TSeDeseFrm;
  begin
    try
      MainFrm_ListView.SetFocus;
    finally
      f := TSeDeseFrm.Create (Self);
      f.Caption := f.SeDeSeFrm_FrmCaptionCB.Items [1];
      if f.ShowModal = mrOk then
        f.DeselectItems (MainFrm_ListView);
      f.Destroy;
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Actions_InvertClick (Sender: TObject);
  var
    f: TSeDeseFrm;
  begin
    try
      MainFrm_ListView.SetFocus;
    finally
      f := TSeDeseFrm.Create (Self);
      f.InvertSelection (MainFrm_ListView);
      f.Destroy;
    end;
  end;



  // ------------------------------------------------------------------- //
  //                                                                     //
  // TMainFrm MainMenu_Options Click                                     //
  //                                                                     //
  // ------------------------------------------------------------------- //

  procedure TMainFrm.MainFrm_MainMenu_Options_ConfigClick (Sender: TObject);
  var
    f: TConfigFrm;
    s1, s2: string;
  begin
    f := TConfigFrm.Create (Self);
    f.ConfigFrm_Notebook.PageIndex := 0;
    f.ConfigFrm_Tree.Items [0].Selected :=True;
    f.Set_Btns_PopupMenu (MainFrm_PopupMenu_Btns);

    s1 := f.ConfigFrm_Skin_SelectCB.Text;
    case f.ShowModal of
      mrCancel: f.Destroy;
      mrOk    : begin
                  f.Get_Btns_PopupMenu;

                  s2 := f.ConfigFrm_Skin_SelectCB.Text;
                  f.SaveAndDestroy;
                  if not (CompareStr (s1, s2) = 0) then
                    myLoadBtnsSkin (BTNsArray);

                  UpdateBtns;  
                end;
    end;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Options_PasswordClick (Sender: TObject);
  var
    f: TPasswordFrm;
  begin
    f := TPasswordFrm.Create (Self);
    if f.ShowModal = mrOK then
    begin
      ShowMessage ('Source code not completed.');
    end;
    f.Destroy;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Options_SaveOnExitClick (Sender: TObject);
  begin
    MainFrm_MainMenu_Options_SaveOnExit.Checked := not MainFrm_MainMenu_Options_SaveOnExit.Checked;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Options_SaveNowClick (Sender: TObject);
  begin
    Save (False);
  end;

  procedure TMainFrm.MainFrm_MainMenu_Options_DefaultClick (Sender: TObject);
  begin
    if MainFrm.Cursor = crDefault then
    begin
      if MessageDlg (MainFrm_MSGs.Items [MSG_default], mtInformation, [mbYes, mbNo], 0) = mrYes then
      begin
        MainFrm_MainMenu_File_Exit.Click;
        if not DeleteFile (ChangeFileExt (ParamStr (0), settingext)) then
          MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_default_error], mtError, [mbOk], 0)
        else
          BG_ShellExecute (ParamStr (0), '');
      end;
    end else
      MessageDlg (Application.Title + ': ' + MainFrm_MSGs.Items [MSG_process], mtInformation, [mbOk], 0);
  end;

  procedure TMainFrm.MainFrm_MainMenu_Options_LogReportClick (Sender: TObject);
  begin
    MainFrm_MainMenu_Options_LogReport.Checked := not MainFrm_MainMenu_Options_LogReport.Checked;
  end;


  
  // -------------------------------------------------------------------------- //
  //                                                                            //
  // TMainFrm MainMenu_Help Click                                               //
  //                                                                            //
  // -------------------------------------------------------------------------- //

  procedure TMainFrm.MainFrm_MainMenu_Help_AboutClick (Sender: TObject);
  var
    f: TAboutFrm;
  begin
    f := TAboutFrm.Create (Self);
    f.ShowModal;
    f.Destroy;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Help_F1Click(Sender: TObject);
  begin
    BG_ShellExecute (DoDelimiter (HLP_FILENAME), ExtractFilePath (ParamStr (0)));
  end;

  procedure TMainFrm.MainFrm_MainMenu_Help_InternetClick(Sender: TObject);
  var
    f: TAboutFrm;
  begin
    f := TaboutFrm.Create (Self);
    f.AboutFrm_LinkClick (Self);
    f.Destroy;
  end;

  procedure TMainFrm.MainFrm_MainMenu_Help_LicenseClick(Sender: TObject);
  var
    f: TAboutFrm;
  begin
    f := TaboutFrm.Create (Self);
    f.BtnLicense.Click;
    f.Destroy;
  end;



  // ------------------------------------------------------------------------- //
  //                                                                           //
  // TMainFrm Btns Click                                                       //
  //                                                                           //
  // ------------------------------------------------------------------------- //

  procedure TMainFrm.BtnUpClick (Sender: TObject);
  begin
    if (not MainFrm_ListView.Up) and (GetBoolValue (UPBTN2EXIT_Class, UPBTN2EXIT_Ident, True)) then
      MainFrm_MainMenu_File_Exit.Click
    else
    begin
      MainFrm_ListViewClick (Self);
      MainFrm_ListView.SetFocus;
    end;  
  end;

  procedure TMainFrm.MainFrm_PathBoxClick (Sender: TObject);
  var
    I: integer;
  begin
    I := MainFrm_PathBox.ItemIndex;
    if not (I = -1 ) then
    MainFrm_ListView.CurrDir := MainFrm_PathBox.Items [I];
    MainFrm_ListViewClick (Self);
    MainFrm_ListView.SetFocus;
  end;

  procedure TMainFrm.MainFrm_ListViewClick (Sender: TObject);
  begin
    if MainFrm.Cursor = crDefault then
    begin
      if MainFrm_ListView.SelCount = 0 then
        MainFrm_StatusBar.Panels [0].Text := Format (MainFrm_MSGs.Items [MSG_n_items], [MainFrm_ListView.Items.Count])
      else
        if MainFrm_ListView.SelCount = 1 then
        begin
          if (TBGNode (MainFrm_ListView.CurrFiles [MainFrm_ListView.Selected.Index]).Attribute and faDirectory) = 0 then
            MainFrm_StatusBar.Panels [0].Text :=
              MainFrm_ListView.Columns [1].Caption +  ': ' + MainFrm_ListView.Selected.SubItems [0] + '  ' +
              MainFrm_ListView.Columns [2].Caption +  ': ' + MainFrm_ListView.Selected.SubItems [1] + '  ' +
              MainFrm_ListView.Columns [3].Caption +  ': ' + MainFrm_ListView.Selected.SubItems [2]
          else
            MainFrm_StatusBar.Panels [0].Text := Format (MainFrm_MSGs.Items [MSG_selected_items], [MainFrm_ListView.SelCount])
        end else
          MainFrm_StatusBar.Panels [0].Text := Format (MainFrm_MSGs.Items [MSG_selected_items], [MainFrm_ListView.SelCount]);
    end;
  end;
  
  // -------------------------------------------------- //
  //                                                    //
  // TMainFrm_PopupMenu                                 //
  //                                                    //
  // -------------------------------------------------- //

  procedure TMainFrm.MainFrm_PopupMenuPopup (Sender: TObject);
  var
    b: bool;
    I: integer;
  begin
    if MainFrm_ListView.SelCount = 0 then
      b := False
    else
      b := True;

    for I := 0 to 8 do
      MainFrm_PopupMenu.Items [I].Visible:= b;
  end;


  


end.


